clear matrix
clear
capture log close
set more off
macro drop _all
set memory 1G  // Jae: you might wanna also increase the memory.
set more off
set matsize 500

set linesize 255
//set maxvar 30000

// Jae: You should change the below directory. 
//global maindirectory ="C:\Users\Serdar\Documents\My Dropbox\GREAT-RECESSION\Data_Serdar"
global maindirectory ="R:\GREAT-RECESSION\Data_Serdar"
//global maindirectory ="C:\Research\GREAT-RECESSION\Stata"
global Jae=0  // Jae: Please change this variable to 1 when you run the code. 
global unix=0  // JAE: Please change this to 1 if you run stata on Unix or Mac

// YOU DON'T NEED TO MAKE ANY CHANGES FROM THIS POINT ON!!!!

global labor=1
if($unix==1){
	global sep="/"
}
else{
	global sep="\"
}

// YOU DON'T NEED TO MAKE ANY CHANGES FROM THIS POINT ON!!!!
global outfolder=c(current_date)
global outfolder="$outfolder DJMP_wage_yr_noage"
capture noisily mkdir "$maindirectory${sep}out${sep}$outfolder"
cd "$maindirectory${sep}out${sep}$outfolder"

capture noisily log using "$maindirectory${sep}log${sep}$outfolder.log", replace
//global DJMP_wage_7811="$maindirectory${sep}do${sep}DJMP_wage_7811.do"
global YRCHNGE_wage_7811="$maindirectory${sep}do${sep}YRCHNGE_wage_7811.do"
do "$maindirectory${sep}do${sep}bymydiststat.do"
do "$maindirectory${sep}do${sep}bymyxtile.do"

global yrfirst = 1978 		// First year in the dataset
global yrlast = 2011 		// Last year in the dataset
global begin_age = 25 
global retire_age = 60
global minobspr = 9		// Minimum number of observations  pre-recession 
global numq = 100		// Number of quintiles

global JMPpercentiles= "1 5 10 25 50 75 90 95 99"
global AGGpercentiles= "p1 p5 p10 p25 p50 p75 p90 p95 p99"
global inclist="wage" // Income list that we analyze
global varoi="wage" // Income list that we analyze

global base_price = 59   /* this is the index of the year 2005 */
global basla=c(current_time)
matrix cpimat = /*  CPI for 1947-2012
*/ (14.126,14.926,14.811,14.989, /*
*/ 16.009,16.337,16.556,16.697,16.764,17.101,17.620,18.035,18.306,18.606, /*
*/ 18.801,19.023,19.245,19.527,19.810,20.313,20.824,21.636,22.616,23.674, /*
*/ 24.681,25.525,26.901,29.703,32.184,33.950,36.155,38.687,42.118,46.642, /*
*/ 50.810,53.615,55.923,58.038,59.938,61.399,63.589,66.121,68.994,72.147, /*
*/ 74.755,76.955,78.643,80.265,82.041,83.826,85.395,86.207,87.596,89.778, /*
*/ 91.489,92.736,94.622,97.098,100.000,102.746,105.564,109.061,109.258, /*
*/ 111.05,113.790,115.784)

matrix minwg = /* Nominal minimum wage 1947-2012
*/ (0.40,0.40,0.40,0.40,0.75,0.75,0.75,0.75,0.75,1.00,1.00,1.00,1.00,1.00, /*
*/ 1.00,1.15,1.15,1.25,1.25,1.25,1.25,1.40,1.60,1.60,1.60,1.60,1.60,1.60, /*
*/ 2.00,2.10,2.10,2.30,2.65,2.90,3.10,3.35,3.35,3.35,3.35,3.35,3.35,3.35, /*
*/ 3.35,3.35,3.80,4.25,4.25,4.25,4.25,4.25,4.75,5.15,5.15,5.15,5.15,5.15, /*
*/ 5.15,5.15,5.15,5.15,5.15,5.85,6.55,7.25,7.25,7.25)

matrix rmininc = J(rowsof(minwg),colsof(minwg), 0.0)
forvalues yr = 1947/2012{
	local cpi_index = `yr'-1947+1
	local deflate = cpimat[1,$base_price]/cpimat[1,`cpi_index']
	matrix rmininc[1,`cpi_index']=40*13*0.5*minwg[1,`cpi_index']*`deflate'
}

matrix agedumwage= (17886.27, 20035.62, 21986.59, 23783.14, 25481.81, 27040.26, 28527.02, 29933.41, 31246, 32470.54, ///
33637.18, 34750.14, 35805.79, 36823.13, 37790.39, 38626.89, 39362.88, 40105, 40652.94, 41259.79, ///
41736.39, 42256.71, 42654.59, 42963.13, 43181.46, 43491.71, 43532.91, 43429.55, 43377.33, 43212.18, ///
42880.82, 42202.92, 41010, 40075.88, 39095.7, 37935.33)

capture noisily log close

local yearfirst=$yrfirst+1
local yearlast=$yrlast-1
forvalues eayr = `yearfirst'/`yearlast'{
	if(`eayr'<$yrfirst+5){
		global minobspr = max(1,`eayr'-$yrfirst-2) // Minimum number of observations  pre-recession 
		global yrbpr = $yrfirst	// Starting year to construct average income pre-period
		global yrepr = `eayr'-1	// Ending year to construct average income pre-period
		global yrbr = `eayr'	// Beginning year of the period (recession or expansion)
		global yrer = min($yrlast,`eayr'+1)	// Ending year of the period (recession or expansion)
		global yr5L = min($yrlast,`eayr'+5)	// Ending year of the period (recession or expansion)
		
	}
	else{
		global minobspr = 3 	// Minimum number of observations  pre-recession 
		global yrbpr = `eayr'-5	// Starting year to construct average income pre-period
		global yrepr = `eayr'-1	// Ending year to construct average income pre-period
		global yrbr = `eayr'	// Beginning year of the period (recession or expansion)
		global yrer = min($yrlast,`eayr'+1)	// Ending year of the period (recession or expansion)
		global yr5L = min($yrlast,`eayr'+5)	// Ending year of the period (recession or expansion)
	}
	do "$YRCHNGE_wage_7811"	
}

