drop _all
use "$maindirectory${sep}dta${sep}cleaned_male_10p_SIC_WAGE_SELFINC_7811"
drop sic*

global DJMPfolder="DJMP_DP$yrbr$yrer"
capture noisily mkdir "$maindirectory${sep}out${sep}$outfolder${sep}$DJMPfolder"
cd "$maindirectory${sep}out${sep}$outfolder${sep}$DJMPfolder"

local yrdrop=$yrbpr-1 
forvalues yr = $yrfirst/`yrdrop'{  
	foreach var in wage selfinc{
		drop `var'`yr'
	}
}
local yrdrop1=$yrer+1
local yrdrop2=$yr5L-1
forvalues yr = `yrdrop1'/`yrdrop2'{  
	foreach var in wage selfinc{
		drop `var'`yr'
	}
}
local yrdrop=$yr5L+1
forvalues yr = `yrdrop'/$yrlast{  
	foreach var in wage selfinc{
		drop `var'`yr'
	}
}

forvalues yr = $yrbpr/$yrbr{
	drop if selfinc`yr'>= rmininc[1,`yr'-1947+1] & selfinc`yr'~=.
	drop selfinc`yr'
}  
drop if selfinc$yrer>= rmininc[1,$yrer-1947+1] & selfinc$yrer~=.
drop selfinc$yrer

if($yr5L>$yrer) {
	drop if selfinc$yr5L>= rmininc[1,$yr5L-1947+1] & selfinc$yr5L~=.
	drop selfinc$yr5L
}

drop if yob > $yrepr -$begin_age +1 
drop if yob < $yrer -$retire_age +1
drop if yod <= $yrer & yod~=.	



gen age$yrepr = $yrepr-yob+1 if yob<=$yrepr & yod>= $yrepr
drop yod

gen agebin$yrepr = .

local bin=1
forvalues h = $begin_age(5)$retire_age{
	replace agebin$yrepr = `bin' if age$yrepr>=`h' & age$yrepr<min(`h'+5,$retire_age)	
	local bin=`bin' +1
}
qui sum agebin$yrepr
local bin=r(max)
replace agebin$yrepr = `bin'  if age$yrepr==$retire_age

matrix avgagedum${varoi}=J(1,$retire_age-$begin_age+1,0)
local dura = $yrepr-$yrbpr+1
local hmax = $retire_age-$begin_age+1
forvalues i=1/`hmax'{
	local dura1=min(`i',`dura')-1
	forvalues j=0/`dura1'{
		matrix avgagedum${varoi}[1,`i']	= avgagedum${varoi}[1,`i'] + agedum${varoi}[1,`i'-`j']
	}
	matrix avgagedum${varoi}[1,`i']	= ln(avgagedum${varoi}[1,`i']/(`dura1'+1))
}

gen  avg${varoi}$yrepr=0
gen  numobs${varoi}$yrepr=0
gen  numallobs${varoi}$yrepr=0
replace numobs${varoi}$yrepr=-5 if ${varoi}$yrepr < rmininc[1,$yrepr-1947+1] | ${varoi}$yrepr==.
forvalues t =$yrbpr/$yrepr{	
	replace avg${varoi}$yrepr=avg${varoi}$yrepr +max(${varoi}`t', rmininc[1,`t'-1947+1]) if ${varoi}`t'~=.
	replace numobs${varoi}$yrepr=numobs${varoi}$yrepr +1 if ${varoi}`t' >= rmininc[1,`t'-1947+1] & ${varoi}`t'~=.
	replace numallobs${varoi}$yrepr=numallobs${varoi}$yrepr +1 if ${varoi}`t'~=.
}
replace avg${varoi}$yrepr = avg${varoi}$yrepr/numallobs${varoi}$yrepr if numobs${varoi}$yrepr >=$minobspr
replace avg${varoi}$yrepr = . if numobs${varoi}$yrepr < $minobspr 
replace avg${varoi}$yrepr = ln(avg${varoi}$yrepr) - avgagedum${varoi}[1,age$yrepr-$begin_age+1] if numobs${varoi}$yrepr >=$minobspr
rename avg${varoi}$yrepr avgres${varoi}$yrepr 
drop numobs${varoi}$yrepr numallobs${varoi}$yrepr age$yrepr

gen avgres${varoi}rankage$yrepr=.
global numq=100
qui bys agebin$yrepr: bymyxtile avgres${varoi}$yrepr avgres${varoi}rankage$yrepr

//	Log of Residual Change in average by Age


gen res${varoi}$yrbr= agedum${varoi}[1,1]*${varoi}$yrbr/agedum${varoi}[1,$yrbr-yob+1-24]
gen res${varoi}$yrer= agedum${varoi}[1,1]*${varoi}$yrer/agedum${varoi}[1,$yrer-yob+1-24]


sort agebin$yrepr  avgres${varoi}rankage$yrepr

by agebin$yrepr  avgres${varoi}rankage$yrepr: egen PRavgres${varoi}age$yrepr =mean(avgres${varoi}$yrepr)
by agebin$yrepr  avgres${varoi}rankage$yrepr: egen PRavgres${varoi}age$yrbr =mean(res${varoi}$yrbr)
by agebin$yrepr  avgres${varoi}rankage$yrepr: egen PRavgres${varoi}age$yrer =mean(res${varoi}$yrer)
gen PRchavgres${varoi}age$yrbr$yrer = log(PRavgres${varoi}age$yrer)-log(PRavgres${varoi}age$yrbr) 	

if($yr5L>$yrer){
	gen res${varoi}$yr5L= agedum${varoi}[1,1]*${varoi}$yr5L/agedum${varoi}[1,$yr5L-yob+1-24]
	by agebin$yrepr  avgres${varoi}rankage$yrepr: egen PRavgres${varoi}age$yr5L =mean(res${varoi}$yr5L)
	gen PRchavgres${varoi}age$yrbr$yr5L = log(PRavgres${varoi}age$yr5L)-log(PRavgres${varoi}age$yrbr) 	
}


egen printtag=tag(agebin$yrepr  avgres${varoi}rankage$yrepr)
outsheet agebin$yrepr  avgres${varoi}rankage$yrepr PR* ///
using PR_JMPres${varoi}age.txt if printtag==1, replace
drop printtag PR*

// 	Average of Residual Changes by Age

gen res${varoi}ch$yrbr$yrer = log(${varoi}$yrer/agedum${varoi}[1,$yrer-yob+1-$begin_age+1]) - log(${varoi}$yrbr/agedum${varoi}[1,$yrbr-yob+1-$begin_age+1]) ///
if ${varoi}$yrer>=rmininc[1,$yrer-1947+1]/3 & ${varoi}$yrbr>=rmininc[1,$yrbr-1947+1] // Residual income change between before and after recession

bymydiststat "res${varoi}ch$yrbr$yrer" "PR" "age" "agebin$yrepr  avgres${varoi}rankage$yrepr"

if($yr5L>$yrer){
	gen res${varoi}ch$yrbr$yr5L = log(${varoi}$yr5L/agedum${varoi}[1,$yr5L-yob+1-$begin_age+1]) - log(${varoi}$yrbr/agedum${varoi}[1,$yrbr-yob+1-$begin_age+1]) ///
	if ${varoi}$yr5L>=rmininc[1,$yr5L-1947+1]/3 & ${varoi}$yrbr>=rmininc[1,$yrbr-1947+1] // Residual income change between before and after recession
	bymydiststat "res${varoi}ch$yrbr$yr5L" "PR" "age" "agebin$yrepr  avgres${varoi}rankage$yrepr"
	
	drop _all
	use PRres${varoi}ch${yrbr}${yr5L}age.dta 
	erase PRres${varoi}ch${yrbr}${yr5L}age.dta
	outsheet using PRres${varoi}ch${yrbr}${yr5L}age.txt, replace	
}


drop _all
use PRres${varoi}ch${yrbr}${yrer}age.dta 
erase PRres${varoi}ch${yrbr}${yrer}age.dta
outsheet using PRres${varoi}ch${yrbr}${yrer}age.txt, replace	


